unit paralelogramma;

interface

uses grafobj, ExtCtrls,Graphics,math;

type TPara = class (TGrafObj)
                   private
                     a,m1,m2:integer;
                   public
                     constructor Create(kx,ky,kdx,kdy,ka,km1,km2:integer; kkep:TImage);
                     procedure kirajzol; override;
                     procedure letorol; override;
                     procedure mozdul; override;
                   end;

implementation

constructor TPara.Create;
begin
 a:=ka;
 m1:=km1;
 m2:=km2;
 inherited Create(kx,ky,kdx,kdy,kkep);
end;

procedure TPara.kirajzol; //kirajzolja a paralelogrammt
begin
 kep.Canvas.Pen.Color := clPurple;
 kep.Canvas.MoveTo(x - a div 2, y);
 kep.Canvas.LineTo(x, y - m1 div 2); //elso haromszog
 kep.Canvas.LineTo(x + a div 2, y);
 kep.Canvas.LineTo(x, y + m2 div 2); //masodik haromszog
 kep.Canvas.LineTo(x - a div 2, y);
end;

procedure TPara.letorol; //letorli a paralelogrammat
begin
 kep.Canvas.pen.Width := 2;
 kep.Canvas.Pen.Color := clWhite;
 kep.Canvas.MoveTo(x - a div 2, y);
 kep.Canvas.LineTo(x, y - m1 div 2); //elso haromszog
 kep.Canvas.LineTo(x + a div 2, y);
 kep.Canvas.LineTo(x, y + m2 div 2); //masodik haromszog
 kep.Canvas.LineTo(x - a div 2, y);
end;

procedure TPara.mozdul; //a paralelogramma mozgasa
var i,j,k : integer;
begin
 letorol;
 i := round(a/2);
 j := round(m1/2);
 k := round(m2/2);
 if (x+dx > kep.Width - i) or (x+dx<i) then dx:=-dx;
 x:=x+dx;
 if (y+dy>kep.Height - min(j,k)) or (y+dy<max(j,k)) then dy:=-dy;
 y:=y+dy;
 kirajzol;
 WriteKoordinata('P');
end;

end.
